
Imports System.Windows.Forms
Imports System
Imports System.Reflection
Imports System.Runtime.InteropServices

<Assembly: AssemblyTitle("ScriptingTest")> 
<Assembly: AssemblyDescription("")> 
<Assembly: AssemblyConfiguration("Release")>
<Assembly: AssemblyCompany("")> 
<Assembly: AssemblyProduct("ThereminoScript")> 
<Assembly: AssemblyCopyright("No Copyright - Theremino System - 2009 2018")> 
<Assembly: AssemblyTrademark("")> 
<Assembly: ComVisible(False)>
<Assembly: Guid("ff17d595-7720-42c5-99a4-e1fe5dd91f92")> 
<Assembly: AssemblyVersion("1.0.0.0")> 
<Assembly: AssemblyFileVersion("1.0.0.0")> 


Public Class Script
	Public Shared Sub Main(ByVal s() As String)
		OpenWebBrowser
		'Application.Run
		Do
			Application.DoEvents
			Threading.Thread.Sleep(1)
		Loop Until ExitFlag
	End Sub
End Class



Module WebBrowser

	Private WithEvents Form1 As Form = New Form
	Private WithEvents PictureBox1 As PictureBox
	Private WithEvents WebBrowser1 As System.Windows.Forms.WebBrowser
	Private WithEvents txtURI As System.Windows.Forms.TextBox
	Private WithEvents btnGo As System.Windows.Forms.Button
	Private WithEvents btnGoBack As System.Windows.Forms.Button
	Private WithEvents btnGoForward As System.Windows.Forms.Button
	Private WithEvents btnStop As System.Windows.Forms.Button
	Private WithEvents btnRefresh As System.Windows.Forms.Button
	Private WithEvents btnHome As System.Windows.Forms.Button
	Private WithEvents lblStatus As System.Windows.Forms.Label

	Public ExitFlag As Boolean = False
	Public Sub OpenWebBrowser()
		Application.EnableVisualStyles
		Form1 = New Form
		InitializeComponent
		Form1.Show
		WebBrowser1.Navigate(txtURI.Text)
	End Sub
	
	
	' ======================================================================
	'  EVENTS
	' ======================================================================

	Private Sub form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Form1.Load
		btnGoBack.Enabled = False
		btnGoForward.Enabled = False
	End Sub
	
	
	Private Sub form1_Closed(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Form1.closing
		ExitFlag = True
		'Application.Exit
		'Application.ExitThread
		'End
	End Sub

	Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
		WebBrowser1.Navigate(txtURI.Text)
	End Sub

	Private Sub btnGoBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGoBack.Click
		If WebBrowser1.CanGoBack Then
			WebBrowser1.GoBack()
		End If
	End Sub

	Private Sub btnGoForward_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGoForward.Click
		If WebBrowser1.CanGoForward Then
			WebBrowser1.GoForward()
		End If
	End Sub

	Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click
		WebBrowser1.Stop()
	End Sub

	Private Sub btnRefresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRefresh.Click
		WebBrowser1.Refresh()
	End Sub

	Private Sub btnHome_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHome.Click
		WebBrowser1.GoHome()
	End Sub

	Private Sub WebBrowser1_CanGoBackChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles WebBrowser1.CanGoBackChanged
		btnGoBack.Enabled = WebBrowser1.CanGoBack
	End Sub

	Private Sub WebBrowser1_CanGoForwardChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles WebBrowser1.CanGoForwardChanged
		btnGoForward.Enabled = WebBrowser1.CanGoForward
	End Sub

	Private Sub WebBrowser1_DocumentCompleted(ByVal sender As System.Object, ByVal e As System.Windows.Forms.WebBrowserDocumentCompletedEventArgs) Handles WebBrowser1.DocumentCompleted
		lblStatus.Text = "Document fully loaded"
	End Sub
	
	Private Sub WebBrowser1_StatusTextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles WebBrowser1.StatusTextChanged
		lblStatus.Text = WebBrowser1.StatusText
	End Sub

	Private Sub WebBrowser1_Navigated(ByVal sender As Object, ByVal e As System.Windows.Forms.WebBrowserNavigatedEventArgs) Handles WebBrowser1.Navigated
		txtURI.Text = WebBrowser1.Url.ToString
	End Sub

	Private Sub WebBrowser1_NewWindow(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles WebBrowser1.NewWindow
		e.Cancel = True
		If WebBrowser1.Document IsNot Nothing Then
			Dim currentElement As HtmlElement = WebBrowser1.Document.ActiveElement
			If currentElement IsNot Nothing Then
				Dim targetPath As String = currentElement.GetAttribute("href")
				WebBrowser1.Navigate(targetPath)
			End If
		End If
	End Sub


	' ======================================================================
	'  INITIALIZE
	' ======================================================================
	
	Private Sub InitializeComponent()
		WebBrowser1 = New System.Windows.Forms.WebBrowser
		txtURI = New System.Windows.Forms.TextBox
		btnGo = New System.Windows.Forms.Button
		btnGoBack = New System.Windows.Forms.Button
		btnGoForward = New System.Windows.Forms.Button
		btnStop = New System.Windows.Forms.Button
		btnRefresh = New System.Windows.Forms.Button
		btnHome = New System.Windows.Forms.Button
		lblStatus = New System.Windows.Forms.Label
		form1.SuspendLayout()
		'
		'WebBrowser1
		'
		WebBrowser1.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
					Or System.Windows.Forms.AnchorStyles.Left) _
					Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
		WebBrowser1.Location = New System.Drawing.Point(0, 33)
		WebBrowser1.MinimumSize = New System.Drawing.Size(20, 20)
		WebBrowser1.Name = "WebBrowser1"
		WebBrowser1.Size = New System.Drawing.Size(1058, 677)
		WebBrowser1.TabIndex = 0
		WebBrowser1.ScriptErrorsSuppressed = True
		'
		'txtURI
		'
		txtURI.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
					Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
		txtURI.AutoCompleteMode = System.Windows.Forms.AutoCompleteMode.SuggestAppend
		txtURI.AutoCompleteSource = System.Windows.Forms.AutoCompleteSource.AllUrl
		txtURI.Location = New System.Drawing.Point(280, 6)
		txtURI.Name = "txtURI"
		txtURI.Size = New System.Drawing.Size(724, 20)
		txtURI.TabIndex = 1
		txtURI.Text = "http://www.google.it"
		'
		'btnGo
		'
		btnGo.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
		btnGo.Location = New System.Drawing.Point(1010, 5)
		btnGo.Name = "btnGo"
		btnGo.Size = New System.Drawing.Size(48, 23)
		btnGo.TabIndex = 2
		btnGo.Text = "Go"
		btnGo.UseVisualStyleBackColor = True
		'
		'btnGoBack
		'
		btnGoBack.Location = New System.Drawing.Point(0, 4)
		btnGoBack.Name = "btnGoBack"
		btnGoBack.Size = New System.Drawing.Size(54, 23)
		btnGoBack.TabIndex = 3
		btnGoBack.Text = "Back"
		btnGoBack.UseVisualStyleBackColor = True
		'
		'btnGoForward
		'
		btnGoForward.Location = New System.Drawing.Point(55, 4)
		btnGoForward.Name = "btnGoForward"
		btnGoForward.Size = New System.Drawing.Size(54, 23)
		btnGoForward.TabIndex = 4
		btnGoForward.Text = "Forward"
		btnGoForward.UseVisualStyleBackColor = True
		'
		'btnStop
		'
		btnStop.Location = New System.Drawing.Point(110, 4)
		btnStop.Name = "btnStop"
		btnStop.Size = New System.Drawing.Size(54, 23)
		btnStop.TabIndex = 5
		btnStop.Text = "Stop"
		btnStop.UseVisualStyleBackColor = True
		'
		'btnRefresh
		'
		btnRefresh.Location = New System.Drawing.Point(165, 4)
		btnRefresh.Name = "btnRefresh"
		btnRefresh.Size = New System.Drawing.Size(54, 23)
		btnRefresh.TabIndex = 6
		btnRefresh.Text = "Refresh"
		btnRefresh.UseVisualStyleBackColor = True
		'
		'btnHome
		'
		btnHome.Location = New System.Drawing.Point(220, 4)
		btnHome.Name = "btnHome"
		btnHome.Size = New System.Drawing.Size(54, 23)
		btnHome.TabIndex = 7
		btnHome.Text = "Home"
		btnHome.UseVisualStyleBackColor = True
		'
		'lblStatus
		'
		lblStatus.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
		lblStatus.Dock = System.Windows.Forms.DockStyle.Bottom
		lblStatus.Location = New System.Drawing.Point(0, 713)
		lblStatus.Name = "lblStatus"
		lblStatus.Size = New System.Drawing.Size(1059, 21)
		lblStatus.TabIndex = 8
		'
		'Form1
		'
		Form1.AcceptButton = btnGo
		Form1.AutoScaleDimensions = New System.Drawing.SizeF(6.0!, 13.0!)
		Form1.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font
		Form1.ClientSize = New System.Drawing.Size(1059, 734)
		Form1.Controls.Add( lblStatus )
		Form1.Controls.Add( btnHome )
		Form1.Controls.Add( btnRefresh )
		Form1.Controls.Add( btnStop )
		Form1.Controls.Add( btnGoForward )
		Form1.Controls.Add( btnGoBack )
		Form1.Controls.Add( btnGo )
		Form1.Controls.Add( txtURI )
		Form1.Controls.Add( WebBrowser1 )
		Form1.Name = "fFullBrowser"
		Form1.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
		Form1.Text = "NetScript demo - ""Web Browser"""
		Form1.ResumeLayout(False)
		Form1.PerformLayout()
	End Sub

End Module